/**
 * Created by tmaxham on 25.08.14.
 */
function log(e)
{
    console.log(e)
}

function debug(e)
{
    if ( !console.debug ) {
        console.debug = function(e) {
            return console.log(e);
        };
    }
    console.debug(e)
}

function errCode(e)
{
    console.error(e)
}

/**
 *
 * @type {{debug: boolean, hbInterface: {clubSearch: string, club: string, login: string, sendScore: string, sendStatus: string}, scripts: string[], anArray: anArray, user: user, pass: pass, getInterface: getInterface, getDate: getDate, alert: alert, parser: {replace: replace, clubSearch: clubSearch, login: login, sendOut: sendOut, sendScore: sendScore}, parse: parse, getClubSearch: getClubSearch, getSpiele: getSpiele, sendOut: sendOut, sendScore: sendScore, resetForm: resetForm, loadScript: loadScript, load: load, showLoading: showLoading, stopLoading: stopLoading, change: change, cleanClub: cleanClub, createListview: createListview, rp: rp, handleClubs: handleClubs, tpl: {empty: string, listContainer: string, cli: string}}}
 */
var HB = {

    debug : false,
    debugInterface : false,

	
    hbInterface : {
        clubSearch : '&cmd=clubSearch&searchString={searched}',
        club : 'cmd=data&lvTypeNext=club&lvIDNext={cID}',
        login : '&cmd=getUpdateList&u={uname}&pw={pword}',
        loginDebug : '&cmd=getUpdateList&u={uname}&pw={pword}&t_now={dtime}',
        sendScore : '&cmd=updateGame&u={uname}&pw={pword}&gHomeGoals_1={hHome}&gGuestGoals_1={hGuest}&gHomeGoals={home}&gGuestGoals={guest}&gID={id}',
        sendScoreDebug : '&cmd=updateGame&u={uname}&pw={pword}&t_now={dtime}&gHomeGoals_1={hHome}&gGuestGoals_1={hGuest}&gHomeGoals={home}&gGuestGoals={guest}&gID={id}',
        sendStatus : '&cmd=updateGame&u={uname}&pw={pword}&gStatus=a&gID={id}',
        sendStatusDebug : '&cmd=updateGame&u={uname}&pw={pword}&t_now={dtime}&gStatus=a&gID={id}'
    },

    scripts : [ 'config', 'extern', 'allSite', 'favSite', 'feedback', 'login', 'results', 'clubs'],

    localSession : [ 'systemuserId', 'systemuserName', 'systemuserPass', 'systemuserTime' ],
    globalSession : [ 'PathId', 'PathStr', 'history', 'type', 'verbandID', 'work_id', 'PathStr' ],


    anArray : function(e)
    {
        return typeof e!=='undefined'?e:[];
    },

    aString : function(e)
    {
        return typeof e!=='undefined'?e:'';
    },

    user : function()
    {
        return localStorage.systemuserName;
    },

    pass : function()
    {
        return localStorage.systemuserPass;
    },

    getInterface : function(e,f)
    {
		if(typeof(f) !== 'undefined') return Config.server + this.hbInterface[e];
        return Config.server + this.hbInterface[e];
    },

    getInterfaceOld : function(e,f)
    {
        console.log("Server: " + Config.server);
        if(typeof(f) !== 'undefined') return Config.server + this.hbInterface[e];
        return Config.server + this.hbInterface[e];
    },

    getDate : function()
    {
        if ( !Date.prototype.toISOString ) {
            (function() {
                function pad(number) {
                    var r = String(number);
                    if ( r.length === 1 ) {
                        r = '0' + r;
                    }
                    return r;
                }
                Date.prototype.toISOString = function() {
                    return this.getUTCFullYear()
                        + '-' + pad( this.getUTCMonth() + 1 )
                        + '-' + pad( this.getUTCDate() )
                        + 'T' + pad( this.getUTCHours() )
                        + ':' + pad( this.getUTCMinutes() )
                        + ':' + pad( this.getUTCSeconds() )
                        + '.' + String( (this.getUTCMilliseconds()/1000).toFixed(3) ).slice( 2, 5 )
                        + 'Z';
                };
            }() );
        }
        var now = new Date();
        return now.toISOString().slice(0,10).replace(/-/g,"-");
    },

    alert : function(msg)
    {
        alert(msg)
    },

    parser : {
        replace : function(string,replace,find)
        {
            for(var i = 0; i < replace.length; i++) {
                string = string.replace(new RegExp('{' + replace[i] + '}', 'gi'), find[i]);
            }
            return string;
        },

        clubSearch : function(searched)
        {
			return this.replace(HB.getInterface('clubSearch',1),['searched'],[searched]);
        },

        login : function(u,p,t)
        {
			u = encodeURIComponent(u);
			p = encodeURIComponent(p);
            t = typeof t !== 'undefined' ? t : HB.getDate();
            var ST = HB.debugInterface?'loginDebug':'login';
            return this.replace(HB.getInterface(ST),['uname','pword','dtime'],[u,p,t]);
        },

        sendOut : function(u,p,t,gameID)
        {
            t = typeof t !== 'undefined' ? t : HB.getDate();
            var ST = HB.debugInterface?'sendStatusDebug':'sendStatus';
            return this.replace(HB.getInterface(ST),['uname','pword','dtime','id'],[u,p,t,gameID]);
        },

        sendScore : function(u,p,t,scores,gameID)
        {
            t = typeof t !== 'undefined' ? t : HB.getDate();
            var ST = HB.debugInterface?'sendScoreDebug':'sendScore';
            var find = ['uname','pword','dtime','hHome','hGuest','home','guest','id'],
                replace = [u,p,t,scores.half_home,scores.half_guest,scores.end_home,scores.end_guest,gameID];
            return this.replace(HB.getInterface(ST),find,replace);
        }
    },

    parse : function(m,a,b,c,d,e,f,g,h,i)
    {
        var url = this.parser[m](a,b,c,d,e,f,g,h,i);
        if(HB.debug) debug('Application is starting to load Interface "'+url+'"');
        return url;
    },

    getClubSearch : function(seek)
    {
        $.getJSON(HB.parse('clubSearch',seek), function(data) {
            HB.handleClubs(data)
        })
    },

	getClubSpiele : function(seek)
    {
        $.getJSON(HB.parse('club',seek), function(data) {
            HB.handleClubs(data)
        })
    },
	
    getSpiele : function(u,p,d)
    {
        $.getJSON(HB.parse('login',u,p,d), function(data) {
            HB.login(data,u,p)
        })
    },

    sendOut : function(u,p,gameID,d)
    {
        $.getJSON(HB.parse('sendOut',u,p,d,gameID), function(data) {
            HB.submittedResult(data);
        });
    },

    sendScore : function(u,p,scores,gameID,d)
    {
        $.getJSON(HB.parse('sendScore',u,p,d,scores,gameID), function(data) {
            HB.submittedResult(data);
        });
    },

    resetForm : function()
    {
        $('#result-form').trigger('reset');
        $('#ergeditor_tore1_half').removeClass('ui-disabled');
        $('#ergeditor_tore2_half').removeClass('ui-disabled');
        $('#ergeditor_tore1').removeClass('ui-disabled');
        $('#ergeditor_tore2').removeClass('ui-disabled');
        $('#ergebniseditor').trigger('create');
    },

    loadScript : function(url)
    {
		var head = document.getElementsByTagName('head')[0];
        var script = document.createElement('script');
        script.type = 'text/javascript';
        script.src = url;
        head.appendChild(script);
    },

    load : function()
    {
		/*
		var appCache = window.applicationCache;
		appCache.update();
		if (appCache.status == window.applicationCache.UPDATEREADY) {
		  appCache.swapCache();  // The fetch was successful, swap in the new cache.
		  console.log("Cache gelscht - reload");
		  window.location.reload(true);
		}
		*/
        $.each(this.scripts, function(e,s)
        {
            var script = 'js/'+s+'.js'; //?ver='+HB.getDate();
            HB.loadScript(script);
            if(HB.debug) debug('The File "' + script + '" was loaded');
        })
    },

    showLoading : function(cls,msg)
    {
        cls = typeof cls !== 'undefined' ? cls : 'a';
        msg = typeof msg !== 'undefined' ? msg : 'Bitte warten...';
        //$.mobile.loadingMessageTextVisible = true;
        $.mobile.loading('show', {theme:cls, text:msg, textonly:false, textVisible: true});
    },

    stopLoading : function()
    {
        $.mobile.loading('hide');
    },

    change : function(page,samePage)
    {
        samePage = typeof samePage !== 'undefined' ? samePage : true;
        $.mobile.changePage(page, { allowSamePageTransition: samePage });
    },

    makeHalle : function(game)
    {
        var halle = this.getHalleInfo(game);
        return (halle != '' && halle != ' ') ? halle : 'Keine Halle vorhanden';
    },

    getHalleInfo : function(game)
    {
		var nummer 	= '';
		var halle 	= '';
		var street 	= '';
		var plz		= '';
		var town 	= '';
		var comment = '';
		var referee = '';
		
		try {
			comment = (typeof game.gComment !== 'undefined' && game.gComment != null && game.gComment.trim() != '') ? game.gComment : '';
			if (comment.match(/^\(\d:\d\)$/)) comment = 'Wertung: ' + comment/*.replace(/[\(\)]/g,'')*/ + ' Punkte'; 
			if (comment != '') comment = "\\n - " + comment; 
		} catch (e) {}

		try {
			referee = (typeof game.gReferee !== 'undefined' && game.gReferee != null && game.gReferee.trim() != '') ? "\\n - SR: " + game.gReferee : '';
		} catch (e) {}
		
		try {
			nummer = (typeof game.gNo !== 'undefined' && game.gNo != null) ? game.gNo : '';
			if(nummer != '') {
				nummer = 'Spiel:\\n - ' + nummer + ((typeof game.gClassSname !== 'undefined' && game.gClassSname != null) ? ' (' + game.gClassSname/*.replace(/["']/g,"\\'")*/ + ')' : '');
			}
		} catch (e) {}
		
		try {
			halle = (typeof game.gGymnasiumName !== 'undefined' && game.gGymnasiumName != null ) ? game.gGymnasiumName/*.replace(/["']/g,"\\'")*/ : '';
			if(halle != '') {
				halle = 'Halle:\\n' + halle + ((typeof game.gGymnasiumNo !== 'undefined' && game.gGymnasiumNo != null) ? ' (' + game.gGymnasiumNo/*.replace(/["']/g,"\\'")*/ + ')' : '') + '\\n';
			}
		} catch (e) {}
		
		try {
			street = (typeof game.gGymnasiumStreet !== 'undefined' && game.gGymnasiumStreet != null ) ? game.gGymnasiumStreet/*.replace(/["']/g,"\\'")*/ : '';
		} catch (e) {}
		
		try {
			plz = ', ' + (typeof game.gGymnasiumPostal !== 'undefined' && game.gGymnasiumPostal != null) ? ' 00000'.substr(0,6-game.gGymnasiumPostal.length) + game.gGymnasiumPostal : '';
		} catch (e) {}
		
		try {
			town = (typeof game.gGymnasiumTown !== 'undefined' && game.gGymnasiumTown != null) ? game.gGymnasiumTown /*.replace(/["']/g,"\\'")*/ : '';
		} catch (e) {}

        return (halle + street + (plz+town==''?'':',' + plz + ' ' + town) + '\\n\\n' + nummer + referee + comment)/*.replace(/\\'/g,"'")*/;
    },

    /**
     *
     * @param data
     * @returns {results,clubs}
     */
    cleanClub : function(data)
    {
        var bNul = {results : 0, clubs : null};
        var obj = typeof(data[0]) !== 'undefined' ? data[0] : null;
        if(obj == null) return bNul;

        var clubs = typeof(obj[0]) !== 'undefined' ? obj[0] : null;
        if(typeof(clubs.resultObjects) !== 'undefined')
            return {results : clubs.numResultObjects, clubs : clubs.resultObjects}

        return bNul
    },

    createListview : function(i,e)
    {
        if(this.debug) debug('Listview created for '+i);
        $(i).html(e);
        $(i).trigger('create');
        $('page').listview('refresh');
    },

    rp : function(s,r,f)
    {
        return HB.parser.replace(s,r,f);
    },

    localRemove : function(arr)
    {
        $.each(arr, function(e,a)
        {
            localStorage.removeItem(a)
        });
    },

    sessionRemove : function(arr)
    {
        $.each(arr, function(e,a)
        {
            sessionStorage.removeItem(a)
        });
    },

    resetSession : function()
    {
        this.sessionRemove(this.globalSession);
        this.localRemove(this.localSession);
    },

	formatResultGame: function(spiel, art) {
		var result = '';
		switch (art) {
			case 'halb':
				result = HB.formatResult(spiel.gHomeGoals_1, spiel.gGuestGoals_1, '(', ')');
				if (result == '' && spiel.gComment.match(/^\(\d:\d\)$/)) {
					result = spiel.gComment;
				}
				break;
			case 'ende':
				result = HB.formatResult(spiel.gHomeGoals, spiel.gGuestGoals, '', '');
				if (result == '' && spiel.gComment.trim() != '') {
					if (spiel.gComment.match(/^\(\d:\d\)$/)) {
						result = ' 0 : 0 ';
					} else if (spiel.gComment.substring(0,2) != 'SR') {
						result = spiel.gComment.substring(0,4) + '...';
					}	
				}
				break;
		}
		return result;
	},
	
    formatResult : function(a, b, pre, post)
    {
        if(typeof a === 'undefined' && typeof b === 'undefined' ) return '';
        if(a == '' && b == '') return '';
        if(a == ' ' && b == ' ') return '';


        a = typeof a !== 'undefined' ? a : 0;
        a = a != '' ? a : 0;
		a = a != ' ' ? a : 0;

        b = typeof b !== 'undefined' ? b : 0;
        b = b != '' ? b : 0;
		b = b != ' ' ? b : 0;

        return pre + a + ' : ' + b + post;
    },

    getTableData : function(data)
    {
        var table = [];
        if(typeof data === 'undefined') return table;

        $.each( data, function(i,item)
        {
            if(typeof item[0] === 'undefined') return;
            if(typeof item[0].tabTeamname === 'undefined') return;
            table = item;
        });

        return table;
    },

    /**
     * Reguliert die Anzeige von gefundenen oder nicht gefundenen Vereinen
     * @param data
     * @returns {*}
     */
    handleClubs : function(data)
    {
        var o = this.cleanClub(data);
        if(o.results == 0)
        {
            HB.alert( 'Ihre Suchanfrage hat keine Vereine gefunden.' );
            return HB.stopLoading();
        }

        var list='';
        $.each(o.clubs, function(e,club)
        {
            var town = club.town != null ? 'Ort: '+club.town : '';
            list+=HB.rp(T.cli,['id','label','town','no'], [club.id,club.lname,town,club.no]);
        });

        HB.createListview('#clubsListed',HB.rp(T.listContainer,['list'], [list]));
        return HB.stopLoading();
    },

    generatePreResultArr : function(item) {
        var data = [
            item.gID,item.gHomeTeam, item.gGuestTeam,item.gHomeGoals,item.gGuestGoals,
            item.gClassSname, item.gDate+' '+item.gTime, item.gNo,
            item.gHomeGoals, item.gGuestGoals, item.gHomeGoals_1, item.gGuestGoals_1,
			item.gComment
        ];
        return data;
    },

    generatePreResultName : function() {
        var data = [
            'gID','homeT', 'guestT','homeG','guestG','staffel','tDate','paarung',
            'hGoal', 'gGoal', 'hGoal_1', 'gGoal_1', 'gComment'
        ];
        return data;
    },

    /**
     * Enthlt die Standard Template Vorlagen
     */
    tpl : {
        empty : '<ul data-role="listview"><li data-role="list-divider">Keine Daten vorhanden</li></ul>',
        listContainer : '<ul data-role="listview">{list}</ul>',
        cli : '<li data-icon="false"><a class="clubPage" clubId="{id}" clubName="{label}" clubNummer="{no}"><h2>{label}</h2><p>{town}</p><p class="ui-li-aside"><strong>{no}</strong></p></a></li>',
        listUsername: '<ul data-role="listview"><li data-role="list-divider">Ergebniseingabe f&uuml;r Benutzer: {user}</li></ul>',
        resPrevList : '<li><a href="#ergebniseditor" game="{gID}" homeT="{homeT}" guestT="{guestT}" staffel="{staffel}" tDate="{tDate}" paarung="{paarung}" hGoal="{hGoal}" gGoal="{gGoal}" hGoal_1="{hGoal_1}" gGoal_1="{gGoal_1}" class="transferToEditor">'
    }

}


HB.login = function(data,u,p)
{
    var errors = '', msg = '', out = '';

    var list = 	T.resPrevList
			
			  +	'<table width="100%" style="font-size: 14px;">'
			  + '<tr>'
			  + '<td width="75%">{staffel}<span style="font-weight: lighter;"> ({paarung}): {tDate}</span></td>'
			  + '<td width="25%" style="text-align: center;">{hGoal} : {gGoal}</td>'
			  + '</tr>'
			  + '<tr>'
			  + '<td >{homeT} - {guestT}</td>'
			  + '<td style="color: #E0E0E0; font-weight: lighter; text-align: center;">({hGoal_1} : {gGoal_1})</td>'
			  + '</tr>'
			  + '<tr>'
			  + '<td rowspan="2" style="font-weight: lighter;"> Hinweis: {gComment}</td>'
			  + '</tr>'
			  + '</table></a></li>';

			
    var $list = $('#eingabeAuswahl');

    $.each(data[0], function(i,item){
        if(i == 'errCode') return;

        errors = item.error;
        msg = item.messageText;
        if(typeof(item.messageText) !== 'undefined') return;

        if(typeof(item.gHomeGoals) !== 'string') item.gHomeGoals = 0;
        if(typeof(item.gGuestGoals) !== 'string') item.gGuestGoals = 0;
        if(typeof(item.gHomeGoals_1) !== 'string') item.gHomeGoals_1 = 0;
        if(typeof(item.gGuestGoals_1) !== 'string') item.gGuestGoals_1 = 0;
		if (item.gComment == 'ausgef.') {
				item.gHomeGoals = '--';
				item.gGuestGoals = '--';
		}
        var data =HB.generatePreResultArr(item);
        out += HB.rp(list,HB.generatePreResultName(), data);
    });

    if(out=='') out = '<li class="ui-li ui-li-static">Keine Spiele verf&uuml;gbar</li>';

    if(errors == true)
    {
        HB.alert(msg);
        HB.stopLoading();
        return;
    }

    //User in Localstorage registrieren
    localStorage.systemuserId = 1;
    localStorage.systemuserName = u;
    localStorage.systemuserPass = p;
    localStorage.systemuserTime = HB.getDate();

    //Weiterleiten auf Registrierungspage
    HB.change('#ergebniseingabe');

    $list.html('<ul data-role="listview" >'+out+'</ul>');
    $list.trigger('create');

    HB.createListview('#userNameDsipl',HB.rp(T.listUsername,['user'], [localStorage.systemuserName]));
    //$('page').listview('refresh');
    HB.stopLoading();
}



HB.submittedResult = function(data)
{
    var msg,errors;
    $.each(data[0], function(i,item)
    {
        if(typeof(item.messageText) !== 'undefined' ) msg = item.messageText;
        if(typeof(item.error) !== 'undefined' ) errors = item.error;
    });


    HB.alert(msg);
    if(errors === false) return HB.finishSubmitting();

    if(HB.debug) errCode('An Error occurred while submitting Game Results!');
    $.mobile.loading('hide');
    return false;
}

HB.finishSubmitting = function()
{
    localStorage.removeItem('gameID');
    $.mobile.loading('hide');
    HB.resetForm();
    return HB.getSpiele(localStorage.systemuserName, localStorage.systemuserPass);
}



/**
 * Ldt die Template Vorlagen
 * @type {*}
 */
var T = HB.tpl;








//Men
function loadBody() {
	Config.load();
	
	window.addEventListener('popstate', function(e){
		console.log("location: , " + document.location + ", state: " + JSON.stringify(e.state)  	+ ', loc: ' + location.hash); 
		if (   (  location.hash != '' 
				&& location.hash.charAt(0) != '#' 
				&& location.hash.indexOf('/') != -1 
				&& location.hash.indexOf('?') != -1)
			|| location.hash.substr(0, 6) == '#main?' 
			|| (e != null && e.state != null && e.state['direction'] == 'back')
			|| (e != null && e.state != null && e.state['url'] == e.state['hash'])
		   ) {
			backButtonClick();
		} else {
			try {
				Extern.writeWerbung();
			} catch (e) {console.log(e);}
		}

	}, false);
	
	Daten.load();
	
	try {
		Extern.writeAppVerweis ();
		Extern.writeWerbungInit ();
	} catch (e) {console.log(e);}

	
}
